SystemOrganization addCategory: #'Mustache-Core'!

Object subclass: #MustacheParser
	instanceVariableNames: 'name version tags view partials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:00'!
debug: aMessage template: aTemplate line: lineNumber file: fileName
|horror|
horror:= 
	aMessage,' in ', 
	(aTemplate copyFrom:1 to: lineNumber),
	'(^v^)' , 
	(aTemplate copyFrom:lineNumber to:aTemplate size),
	String crlf ,
	'Char:', lineNumber asString, 
	String crlf. 
Transcript show: horror.
^horror! !

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 11:07'!
initialize 
super initialize.
name:='mustache'.
version:= '0.5.0-dev'.
tags:= Array with:'{{' with:'}}'.

! !

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/23/2012 19:38'!
messageSelectorAndArgumentNames
| stack |
[:aView :aPartials|
		|buffer line|
	 	buffer:= ReadWriteStream on:''.
	 	line:=1.
	 	buffer nextPutAll:'*'.
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'nombre' stack:stack defaultValue: (String new))).
buffer nextPutAll:'*'
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
buffer nextPutAll:'
*'
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'empresa' stack:stack defaultValue: (String new))).
buffer nextPutAll:'
*'
.

line:=1.
		buffer nextPutAll: (self lookup:'empresa' stack:stack defaultValue: (String new)).
	buffer nextPutAll:'
'
.

line:=1.
		[ |nameexperiencia callbackexperiencia|
		nameexperiencia:='experiencia'.
		callbackexperiencia:=[ 
			|bufferexperiencia|
			bufferexperiencia:=ReadWriteStream on:''.
			bufferexperiencia nextPutAll:'--'
.

line:=1.
		bufferexperiencia nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
bufferexperiencia nextPutAll:'
'
.
bufferexperiencia contents].

	buffer nextPutAll: (self renderSection:nameexperiencia view:stack callback:callbackexperiencia).
			buffer contents.
			] value.
	buffer nextPutAll:'
'
.

line:=1.
		[ |nametasas callbacktasas|
		nametasas:='tasas'.
		callbacktasas:=[ 
			|buffertasas|
			buffertasas:=ReadWriteStream on:''.
			buffertasas nextPutAll:''.

line:=1.
		buffertasas nextPutAll: (self escapeHTML:(self lookup:'paga' stack:stack defaultValue: (String new))).
buffertasas nextPutAll:' por '
.

line:=1.
		buffertasas nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
buffertasas nextPutAll:'
'
.
buffertasas contents].

	buffer nextPutAll: (self renderSection:nametasas view:stack callback:callbacktasas).
			buffer contents.
			] value.
	buffer nextPutAll:''.
	buffer contents].! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:42'!
name
	^ name! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
name: anObject
	name := anObject! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 5/19/2012 00:21'!
parse: aTemplate 
"Parses the given 'template' and returns the source of a function that, with the proper arguments, will render the template. Recognized options include the following:
- file The name of the file the template comes from (displayed in error message)
- tags An Array of open and close tags the template uses. Defaults to the value of Mustache tags instance variable.
- debug Set 'true' to log the body of the generated function to the console.
- space Set 'true' to preserve whitespaces from lines that otherwise contain only a {{tag}}. Default to 'false' "

self parse: aTemplate options:(JsonObject new)! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 12/18/2012 09:39'!
parse: aTemplate options:aJsonObjOptions
"Parses the given 'template' and returns the source of a function that, with the proper arguments, will render the template. Recognized options include the following:
- file The name of the file the template comes from (displayed in error message)
- tags An Array of open and close tags the template uses. Defaults to the value of Mustache tags instance variable.
- debug Set 'true' to log the body of the generated function to the console.
- space Set 'true' to preserve whitespaces from lines that otherwise contain only a {{tag}}. Default to 'false' "

|myTags code openTag closeTag spaces hasTag nonSpace streapSpace sectionStack updateLine nextOpenTag nextCloseTag setTags includePartial openSection line  openInvertedSection closeSection sendPlain sendEscaped codeInject c callback i end sourceCode lastI |

myTags:=aJsonObjOptions at:'tags' ifAbsent:[self tags].
openTag:=myTags at:1.
closeTag:=myTags at:2.
code:= ReadWriteStream on:''.
sectionStack:=Stack new.
code  
		nextPutAll: 	'[:aView :aPartials|
		|buffer|
		
		html ifNil:[buffer:= ReadWriteStream on:',$' asString,$' asString,']
			 		ifNotNil:[buffer:= html document].
	 	line:=0.
	 	buffer nextPutAll:';nextPut:$'.

	
spaces:=Stack new.   "Indices of whitespace in code on the current line"
hasTag:= false.      "Is there a {{tag}} on the current line"	
nonSpace:= false.      "Is there a non-space char on the current line"

streapSpace:=[
	(hasTag and:[nonSpace not and:[(aJsonObjOptions at:'space' ifAbsent:[false]) not]])	
	ifTrue:[
		"???? TODO"
		]
	].

setTags:=[:source :bool :aName|
	|section|
	myTags:= source trimSpaces subStrings: (Character space asString).
	nextOpenTag:= myTags at:1.
	nextCloseTag:=myTags at:2.		
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code nextPutAll: '.
		buffer',section ,' nextPutAll:';nextPut:$'.
	 ].

includePartial:=[:source :bool :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll:'[|partial|
			partial:= self partials at:';
		nextPut: $';
		nextPutAll: source trimSpaces;
		nextPut: $';
		nextPutAll:' ifAbsent:[nil].
		partial ifNotNil:[ buffer', section  ,' nextPutAll: (self render:partial view: (stack last) partials:self partials)]] value.';crlf;
		nextPutAll:'buffer', section  ,' nextPutAll:';nextPut:$'.
	].

openSection:=[:source :inverted |
	|aName|
	aName:= source trimSpaces.
	(aName = '') ifTrue: [self debug:'Section name may not be empty' template:aTemplate line:line file:(aJsonObjOptions at:'file')].
	
	sectionStack push: (JsonObject fromAssociations: {'name'-> aName. 'inverted'->inverted}).
	code  nextPutAll: '.';crlf;
		nextPutAll:  updateLine;
		nextPutAll: '
		[ |name',aName ,' callback',aName ,'|
		name',aName ,':=';
		nextPut: $';
		nextPutAll: aName; 
		nextPut: $';
		nextPut: $.;
		nextPutAll:'
		callback',aName ,':='; nextPut:$'.
].

openInvertedSection:= 	[:source|
	openSection value:source value:true.		
	] .

closeSection:=[:source |
	|aName section openName|
	aName:= source trimSpaces.
	openName:=nil.
	(sectionStack size > 0) 
	ifTrue:[
		openName:=sectionStack pop. 
	].

	(openName name isNil or:[(aName = openName name) not]) 
	ifTrue: [
		self error: (self debug:'Section name may not be empty' template:aTemplate line:line file:(aJsonObjOptions at:'file'))
		].
	section:=openName.
	code  nextPutAll: '.';crlf.

	(section at:'inverted' ifAbsent:[false]) 
	ifTrue:[
		code crlf;nextPutAll:'	buffer nextPutAll: (self renderSection:name',aName ,' view:stack callback:callback',aName ,' inverted:true).
			buffer contents.
		] value.'.
		]
	ifFalse:[
		code crlf;nextPutAll:'	buffer nextPutAll: (self renderSection:name',aName ,' view:stack callback:callback',aName ,').
			buffer contents.
			] value.'.
		].
	code crlf;
	nextPutAll:'	buffer nextPutAll:';nextPut:$'.

].

sendPlain:=[:source :bool :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll:  updateLine;
		nextPutAll: '
		buffer',section ,' nextPutAll: (self lookup:';
		nextPut:$';
		nextPutAll: source trimSpaces ;
		nextPut:$';
		nextPutAll:' stack:stack defaultValue: (String new)).';
		crlf;
		nextPutAll:'	buffer',section ,' nextPutAll:';nextPut:$'.
	].

sendEscaped:=[:source :bool  :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll: '
		buffer',section ,' nextPutAll: (self escapeHTML:(self lookup:';
		nextPut:$';
		nextPutAll: source trimSpaces ;
		nextPut:$';
		nextPutAll:' stack:stack defaultValue: (String new))).';
		crlf;
		nextPutAll:'buffer',section ,' nextPutAll:';nextPut:$'.
	].

codeInject:=[:source :bool  :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll: source trimSpaces ;
		crlf;
		nextPutAll:'buffer',section ,' nextPutAll:';nextPut:$'.
	].


line:=1. i:=1. lastI:=1.
i:=aTemplate findString: openTag startingAt: i.

((i - lastI)>0) ifTrue:  [
		|pos|
		pos:= (i=1) ifTrue:[1] ifFalse:[i-1].
		code nextPutAll:( aTemplate copyFrom:lastI to:(pos)).
		code nextPut:$';nextPut:$.;crlf.
	] ifFalse:[
		(i>0) ifTrue:[ code nextPut:$';crlf]].

[i >0] whileTrue:[
	c:= aTemplate at:(i + (openTag size)) .
	line:=i.
	updateLine:=  '
	line:=' , line asString, '.'.
	nextOpenTag:=openTag.
	nextCloseTag:=closeTag.
	hasTag:=true.
	i:= (i + (openTag size)).
	nonSpace:=true.
	callback:=sendEscaped.
	(c=$!!) ifTrue:[
		i:=i+1.
		callback:=nil.
		].
	(c=$=) ifTrue:[
		i:=i+1.
		closeTag:= '=' , closeTag.
		callback:=setTags.
		].
	(c=$>) ifTrue:[
		i:=i+1.
		callback:=includePartial
		].
	(c=$#) ifTrue:[
		closeTag:= closeTag.
		"we change next open tag to find the closing section tag for this section"
		"needs to skip one crlf"
		i:=i+1.
		callback:=openSection
		].
	(c=$^) ifTrue:[
		i:=i+1.
		callback:=openInvertedSection
		].
	(c=$/) ifTrue:[
		closeTag:= closeTag.
			"needs to skip one crlf"
		i:=i+1.
		callback:=closeSection
		].
	(c=${) ifTrue:[
		i:=i+1.
		closeTag:='}' , closeTag.
		callback:=sendPlain.
		].
	(c=$&) ifTrue:[
		i:=i+1.
		nonSpace:=true.
		callback:=sendPlain.
		].
	(c=$[) ifTrue:[
		i:=i+1.
		nonSpace:=true.
		closeTag:=']' , closeTag.
		callback:=codeInject.
		].
	end:=(aTemplate findString: closeTag startingAt:i).
	(end = 0) ifTrue: 
		[self error: (self debug:('Tag ', openTag, ' was not closed properly') template:aTemplate line:line file:(aJsonObjOptions at:'file'))].
	
	
	sourceCode:= (aTemplate copyFrom:i to: (end - 1)).
	
	callback 
	ifNotNil:
		[callback valueWithEnoughArguments: (Array with:sourceCode with:false with: (
			sectionStack isEmpty ifTrue:[nil]
								  ifFalse:[sectionStack top]))]
	ifNil:
		[code nextPutAll: 'buffer nextPutAll:';nextPut:$'.].
	lastI:= (end + closeTag size).
	openTag:=nextOpenTag.
	closeTag:=nextCloseTag.
	
	"only in open secction"
	(c=$#) ifTrue:[
		"we change open tag to find the closing section tag for this section"
		openTag:= openTag , '/' , sourceCode.
	].
	
	i:=aTemplate findString: openTag startingAt:lastI.
	
	((i - lastI)>=0) ifTrue:  [
			|pos|
			pos:= (i=1) ifTrue:[1] ifFalse:[i-1].
			lastI:=self skipOneCrlfOn:aTemplate at:lastI command:c.
			(callback=openSection) 
			ifTrue:[
				code nextPutAll:( Mustache clearComma: (aTemplate copyFrom:lastI to:pos)).
				code nextPut:$';crlf]
			ifFalse:[
				code nextPutAll:( aTemplate copyFrom:lastI to:pos).
				code nextPut:$';crlf.
			]
		].
	(c=$#) ifTrue:[
		"restore the real openTag"
		openTag:= nextOpenTag.
	].
	].
	
	(sectionStack size=0) ifFalse: [self error: (self debug:('Section ', ((sectionStack pop) at:'name'), ' was not closed properly') template:aTemplate line:line file:(aJsonObjOptions at:'file'))].
	lastI:=self skipOneCrlfOn:aTemplate at:lastI command:c.
	code nextPutAll: ( aTemplate copyFrom:lastI to:(aTemplate size)).
	code nextPut:$';
		nextPutAll: '.
	html ifNil:[buffer contents]
		ifNotNil:[nil].
	].'.
^code.	! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 6/18/2012 13:30'!
skipOneCrlfOn:aTemplate at:lastI command:aChar
"skips one CRLF to avoid multiple line break after clossing a section"
(aTemplate size > lastI) ifTrue:[

	(((aTemplate at: lastI )= Character cr ) and: [(aChar=$# or:[aChar=$^]) or:[aChar=$/]])
	 ifTrue:[
		|i|
		i:= lastI+1.
		((aTemplate at:i) = Character lf) ifTrue: [i:= i+1].
		^i.
		]
	].
^lastI

! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
tags
	^ tags! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:42'!
tags: anArrayOfTwoDelimiters
	tags := anArrayOfTwoDelimiters! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
version
	^ version! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
version: anObject
	version := anObject! !

JsonObject subclass: #Mustache
	instanceVariableNames: 'stack parser sem html line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

Mustache class
	instanceVariableNames: 'cache'!

Mustache class
	instanceVariableNames: 'cache'!

!Mustache class methodsFor: 'accessing' stamp: 'JesusMari 12/8/2012 12:12'!
cache
^cache ifNil:[cache:=MustacheCache new]! !

!Mustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:25'!
clearCache
cache removeAll.
cache:=nil! !

!Mustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:22'!
clearComma:aTemplate
	"Replace all the $' occurrences by $'' you need this if you read a template from a file or compile a section"
	| templ |
	templ:=WriteStream on:''.
	(1 to:aTemplate size) do:[:index|
	
		((aTemplate at:index) = $')
		 	ifTrue:[templ nextPut:$';nextPut:$']
			ifFalse:[templ nextPut:(aTemplate at:index)]
	].

	^ templ contents.


! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/30/2012 10:38'!
instanceFromFolder:aFolderPath 
|instance|
instance:=self new.
instance importAllTemplatesFrom:aFolderPath relPath:''.
^instance! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/22/2012 17:05'!
render:aTemplate view:aView 
^Mustache toHtml:aTemplate view:aView
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/21/2012 22:12'!
render:aTemplate view:aView  partials:aPartialNode
^Mustache toHtml:aTemplate asString view:aView partials:aPartialNode
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/30/2012 10:58'!
toHtml:aTemplate view:aView 

^Mustache toHtml:aTemplate view:aView partials:nil
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 12/9/2012 10:07'!
toHtml:aTemplate view:aView on:aHtmlCanvas
^ self toHtml:aTemplate view:aView partials:nil on:aHtmlCanvas! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 12/9/2012 10:07'!
toHtml:aTemplate view:aView partials:partialsNode
^ self toHtml:aTemplate view:aView partials:partialsNode on:nil
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 12/17/2012 10:25'!
toHtml:aTemplate view:aView partials:partialsNode on: html
| compiler tmp templ aTempl|

compiler:=self new.
compiler html:html.

(aTemplate class superclass = MustacheTemplate class) 
ifTrue:[
		aTempl:=aTemplate instance render.
		compiler partials:aTemplate partials.
	]
ifFalse:[
	partialsNode ifNil:[compiler partials]
				ifNotNil:[compiler partials: partialsNode].
	aTempl:=  aTemplate.
	].
^ compiler render: aTempl view: aView. 

! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:09'!
clearCache

self class cache removeAll.



! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 10:38'!
compile:aTemplate 
"Compiles the given ttemplate into a reusable function using the given options. In addiction to the options accepted by #parse: options: recogniced options include the folllowing:
- cache 	Set 'false' to bypass any pre-compiled version of the given template. Otherwise, a given 'template' string will be cached the first time it is parsed"
	
	^self compile:aTemplate options:JsonObject new! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:12'!
compile:aTemplate options:aJsonObjOptions
"Compiles the given template into a reusable function using the given options. In addiction to the options accepted by #parse: options: recogniced options include the folllowing:
- cache 	Set 'false' to bypass any pre-compiled version of the given template. Otherwise, a given 'template' string will be cached the first time it is parsed"
	
| cblock |
self class cache manageCacheSize.
( aJsonObjOptions at:'cache' ifAbsent:[true])
ifTrue:[
	cblock:=self class cache 
				at:aTemplate 
				ifAbsent:[self rcompile:aTemplate options:aJsonObjOptions].
	cblock ifNotNil:[
		cblock outerContext receiver html: html.
		cblock outerContext receiver stack: stack.
		self class cache at:aTemplate put: cblock].	.

	^cblock.	
	].
^  self rcompile:aTemplate options:aJsonObjOptions! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:19'!
escapeHTML: aString
|result table |


table:=JsonObject fromAssociations: {
	'&'-> '&amp;'.
	'<'->'&lt;'.
	'>'->'&gt;'.
	'"'->'&quot;'.
	''''->'&#39;'.
	}.

result:= aString asString copyWithRegex: '[&<>"'']+' matchesTranslatedUsing: [:ch| table at: ch].

^result! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:19'!
escapePlain: aString

^aString asString! !

!Mustache methodsFor: 'instance creation' stamp: 'JesusMari 12/17/2012 10:14'!
importAllTemplatesFrom:aFolderPath relPath:relPath
| dir a elements attchPath fileName aStream instance|

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllTemplatesFrom:aFolderPath relPath:(entry name)]
			ifFalse:[	self importAllTemplatesFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		(relPath='') 
			ifFalse:[
				attchPath:=(relPath , FileDirectory pathNameDelimiter asString, fileName).
				attchPath:= attchPath copyReplaceAll: '\' with: '/'.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self partials at: attchPath put: (Mustache clearComma: aStream contents)
				]
			ifTrue:[
				attchPath:= fileName.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self  at: attchPath put: (Mustache clearComma: aStream contents)
				].
	]
]! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 10:08'!
initialize:size 
super initialize:size.
line:=0.
stack:= OrderedCollection new.
parser:=MustacheParser new.



! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/21/2012 03:07'!
lookup:name stack:aStack 
"looks up the value of the given 'name' in the given context 'stack'"

^self lookup:name stack:aStack defaultValue:nil! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:29'!
lookup:name stack:aStack defaultValue:defaultValue
"looks up the value of the given 'name' in the given context 'stack'"
|names lastIndex target value context i j localStack|
(name = '.') ifTrue:[	^ aStack last	].
names:= name subStrings:'.'.
lastIndex:= names size.
target:= names at:lastIndex.

i:=aStack size.
localStack:=aStack copy.

i to:1 by: -1 do:[:pos|
	context := aStack at: pos.
	j:=1.
	[(j < lastIndex) and:[context notNil]] whileTrue:[
		context:=context at: (names at:j).
		j:= j + 1.
		localStack add: context.	
	].

	
	context ifNotNil:[
		((context isKindOf: JsonObject) and:[ context includesKey: target]) ifTrue:[
			value:= context at:target.
			(value isKindOf: BlockClosure) ifTrue:[
				value:= value valueWithEnoughArguments: (Array with: localStack last with:html)].
			value ifNil:[^defaultValue].
			(value isKindOf:WAObject) ifTrue:[value:=''].
			^value.
		]
	]
].
(value isKindOf: BlockClosure) ifTrue:[
	value:= value valueWithEnoughArguments: (Array with: localStack last with:html)].
value ifNil:[^defaultValue].
^value.! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/23/2012 19:44'!
parser
	^ parser! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/23/2012 19:44'!
parser: anObject
	parser := anObject! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 9/30/2012 10:46'!
partials
^ self at:'partials' ifAbsent:[self at:'partials' put: JsonObject new].
	! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 9/27/2012 18:01'!
partials: anObject
	self at:'partials' put:anObject! !

!Mustache methodsFor: 'private' stamp: 'JesusMari 12/18/2012 10:09'!
rcompile:aTemplate options:options

| body context compiledBlock  | 
body:= parser parse: aTemplate options: options.

[
	compiledBlock:= (Compiler evaluate:body contents for: self logged:false ).
	compiledBlock ifNil:[self error:'Compilation Error']
]on:Error
do:[:err|
	Transcript show: (err description, String crlf);
		show: (line asString , String crlf);
		show: (aTemplate truncateTo: 80), String crlf;
		show:body contents, String crlf].
^ compiledBlock ! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 10:44'!
render: aTemplate view:aView 
"High-level function that renders the given 'template' using the given 'view' and 'partials'. If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "
^self render:aTemplate view:aView partials:self partials! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:08'!
render: aTemplate view:aView partials:partialsTemp
"High-level function that renders the given 'template' using the given 'view' and 'partials'. If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "

| cm str|

(aView isKindOf:OrderedCollection ) 
	ifTrue:[self stack:aView]
	ifFalse:[self stack: (OrderedCollection with:aView)].
self partials:partialsTemp.
cm:= self compile:aTemplate.

str:=html ifNil:[(cm valueWithEnoughArguments: (Array with:aView with:self partials)) contents]
		ifNotNil:[cm valueWithEnoughArguments: (Array with:aView with:self partials)].
		
str ifNil:[str:=''].
^str! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/21/2012 02:59'!
renderSection:name view: aStack callback: callback
^ self renderSection:name view: aStack callback: callback inverted:false.
! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 10:52'!
renderSection:name view: aStack callback: callback inverted:inverted

| buffer value scopeRender callbackResult block|
buffer:= ReadWriteStream on:''.
value:= self lookup: name stack: aStack.
callbackResult:=callback value.
"a bit of magic..."

inverted 
ifTrue: [
	"From the spec: inverted sections may render text once based on the inverse value of the key. That is, they will be rendered if the key doesn't exist, is false, or is an empty list"
	value ifNil:[buffer nextPutAll: (callback value )	].
	((value isKindOf:Boolean) and:[value not]) ifTrue:[buffer nextPutAll: (
		Mustache toHtml:callbackResult view:stack last partials:self partials on:html )	].		
	((value isKindOf:Array) and:[value isEmpty]) ifTrue:[buffer nextPutAll: (
		Mustache toHtml:callbackResult view:stack last partials:self partials on:html) 	].	
	]
ifFalse:[
	(value isKindOf:Array)
	ifTrue:[
		value do:[:val|
			stack add:val.
			buffer nextPutAll:  (Mustache 	toHtml:callbackResult 
											view: stack 
											partials:self partials
											on:html).
			stack remove:val.
			]
		]
	ifFalse:[
		(value isKindOf:JsonObject)
		ifTrue:[
			stack add:value.
			buffer nextPutAll:  (Mustache 	toHtml:callbackResult 
											view:stack first
											partials:self partials
											on:html).
			stack remove:value.
			]
		ifFalse:[
			(value isKindOf:BlockClosure)
			ifTrue:[
				block:=Compiler evaluate:value for: self logged: false.
				buffer nextPutAll: (
					Mustache 	toHtml: (block valueWithEnoughArguments: (
									Array with: (callback value )
										   with: stack last) ) 
								view:stack last 
								partials:self partials
								on:html).
				]
			ifFalse:[
				(value notNil and:[(value isKindOf:Boolean) ifTrue:[value] ifFalse:[true]]) ifTrue: [
					buffer nextPutAll: (
					Mustache
					 toHtml:callbackResult view:stack last partials:self partials on:html)].
				]
			] 
		
		]
	].
^buffer contents! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 10:53'!
renderTemplateAt: aTemplate view:aView 
"High-level function that renders the given 'template' located in the partials node, using the given 'view'  If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "


^ self render: (self class clearComma:(self at:aTemplate)) view:aView.
! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:40'!
stack
	^ stack! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:40'!
stack: anObject
	stack := anObject! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/19/2012 02:34'!
tags
	parser tags! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/19/2012 02:35'!
tags: twoTags
	parser tags:twoTags! !

JsonObject subclass: #MustacheTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

MustacheTemplate class
	instanceVariableNames: 'instance'!

MustacheTemplate class
	instanceVariableNames: 'instance'!

!MustacheTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 13:40'!
instance
|sub|
super initialize.
instance:=self new.
self subclasses do:[:aSubClass|
	instance addPartial: aSubClass instance.
].
instance initialize.
^instance! !

!MustacheTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/21/2012 22:16'!
partials
^ self instance partials! !

!MustacheTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 20:13'!
addPartial:aMustachePartial

| p |
p:=self at:'partials' ifAbsent:[self at:'partials' put: JsonObject new].
p at:(aMustachePartial class asString) put:(aMustachePartial render)
! !

!MustacheTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2012 12:32'!
render
	"return an Template within a string"
self subclassResponsibility ! !

Dictionary subclass: #MustacheCache
	instanceVariableNames: ''
	classVariableNames: 'monitor'
	poolDictionaries: ''
	category: 'Mustache-Core'!

!MustacheCache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 11/7/2012 11:37'!
cacheSize
"Cache size> when the size is grater than xxx deletes a half of the cached templates"
^50! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:28'!
at: sourceCode
	
	| a |
	monitor critical: [
		a:=super at:sourceCode.
		monitor signal
		].
	^a
	! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:59'!
at: sourceCode ifAbsent:aBlock
	
	| a |
	monitor critical: [
		a:=super at:sourceCode ifAbsent:aBlock.
		monitor signal
		].
	^a
	! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:59'!
at: sourceCode put:aCompiledSourceCode
	
	| a |
	 monitor critical: [
		a:=super at:sourceCode put:aCompiledSourceCode.
		monitor signal
		].
	^a
	! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 10/4/2012 10:16'!
initialize:size
super initialize:size.
monitor:=Monitor new! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:51'!
manageCacheSize
"removes the elements from 1 to cacheSize/2 if the size is greater than #cacheSize "
monitor critical:[
(super size > self class cacheSize) ifTrue:[
	super keys do:[:aKey|
		super removeKey: aKey.
		(super size < ((self class cacheSize / 2 ))) ifTrue:[
			monitor signal.
			 ^self].
		]
	].
].

^ self! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 10:00'!
removeAll

      monitor critical: [
		super removeAll.
		monitor signal
      ].
 	


! !
